diff --git a/kernel/sched.c b/kernel/sched.c
index 7cc00ea..530d97f 100644
--- a/kernel/sched.c
+++ b/kernel/sched.c
@@ -484,6 +484,8 @@ static inline struct task_group *task_group(struct task_struct *p)
 struct cfs_rq {
 	struct load_weight load;
 	unsigned long nr_running;
+	unsigned long nr_sleep; /* intr */
+	unsigned long nr_unintr;
 #ifndef __GENKSYMS__
 	unsigned long h_nr_running;
 #endif
@@ -580,6 +582,7 @@ struct cfs_rq {
 	struct list_head throttled_list;
 
 	struct list_head boosted_entities;
+	unsigned long nr_boosted_on_wakeup;
 #endif
 #ifdef CONFIG_CFS_CPULIMIT
 	int active;
@@ -796,7 +799,8 @@ struct rq {
 #endif
 
 #ifndef __GENKSYMS__
-	unsigned int skip_clock_update;
+	unsigned char skip_clock_update;
+	unsigned char resched_next;
 #endif
 	/* capture load from *all* tasks on this cpu: */
 	struct load_weight load;
@@ -890,10 +894,6 @@ struct rq {
 	struct hrtimer hrtick_timer;
 #endif
 
-#ifdef CONFIG_CFS_BANDWIDTH
-	int cfs_quota_exceeded;
-#endif
-
 #ifdef CONFIG_SCHEDSTATS
 	/* latency stats */
 	struct sched_info rq_sched_info;
@@ -3283,12 +3283,6 @@ static void finish_task_switch(struct rq *rq, struct task_struct *prev)
 	}
 }
 
-static inline void task_scheduled(struct rq *rq, struct task_struct *p)
-{
-	if (p->sched_class->task_scheduled)
-		p->sched_class->task_scheduled(rq, p);
-}
-
 #ifdef CONFIG_SMP
 
 /* assumes rq->lock is held */
@@ -3501,6 +3495,7 @@ unsigned long nr_running_ve(void)
 
 /* Variables and functions for calc_load */
 static atomic_long_t calc_load_tasks;
+EXPORT_SYMBOL(calc_load_tasks);
 static unsigned long calc_load_update;
 unsigned long avenrun[3];
 EXPORT_SYMBOL(avenrun);
@@ -3571,12 +3566,31 @@ static void calc_load_ve(void)
 	CALC_LOAD(kstat_glob.nr_unint_avg[1], EXP_5, nr_unint);
 	CALC_LOAD(kstat_glob.nr_unint_avg[2], EXP_15, nr_unint);
 	spin_unlock_irqrestore(&kstat_glb_lock, flags);
-
 }
 #else
 #define calc_load_ve()	do { } while (0)
 #endif
 
+static void (*loadavg_ptr)(void);
+static unsigned long loadavg_ptr_bits;
+static DECLARE_WAIT_QUEUE_HEAD(loadavg_ptr_wq);
+#define LA_PTR_STOP_BIT	0
+
+void loadavg_ptr_fini()
+{
+	if (loadavg_ptr != NULL) {
+		set_bit(LA_PTR_STOP_BIT, &loadavg_ptr_bits);
+		wait_event(loadavg_ptr_wq, (loadavg_ptr == NULL));
+	}
+}
+EXPORT_SYMBOL(loadavg_ptr_init);
+
+void loadavg_ptr_init(void (*ptr)(void))
+{
+	loadavg_ptr = ptr;
+}
+EXPORT_SYMBOL(loadavg_ptr_fini);
+
 /*
  * calc_load - update the avenrun load estimates 10 ticks after the
  * CPUs have updated calc_load_tasks.
@@ -3589,14 +3603,23 @@ void calc_global_load(void)
 	if (time_before(jiffies, upd))
 		return;
 
-	active = atomic_long_read(&calc_load_tasks);
-	active = active > 0 ? active * FIXED_1 : 0;
+	if (loadavg_ptr != NULL) {
+		(*loadavg_ptr)();
+		if (test_bit(LA_PTR_STOP_BIT, &loadavg_ptr_bits)) {
+			loadavg_ptr = NULL;
+			wake_up(&loadavg_ptr_wq);
+			clear_bit(LA_PTR_STOP_BIT, &loadavg_ptr_bits);
+		}
+	} else {
+		active = atomic_long_read(&calc_load_tasks);
+		active = active > 0 ? active * FIXED_1 : 0;
 
-	avenrun[0] = calc_load(avenrun[0], EXP_1, active);
-	avenrun[1] = calc_load(avenrun[1], EXP_5, active);
-	avenrun[2] = calc_load(avenrun[2], EXP_15, active);
+		avenrun[0] = calc_load(avenrun[0], EXP_1, active);
+		avenrun[1] = calc_load(avenrun[1], EXP_5, active);
+		avenrun[2] = calc_load(avenrun[2], EXP_15, active);
 
-	calc_load_ve();
+		calc_load_ve();
+	}
 
 	calc_load_update += LOAD_FREQ;
 }
@@ -6506,6 +6529,7 @@ asmlinkage void __sched schedule(void)
 	struct task_struct *prev, *next;
 	unsigned long *switch_count;
 	struct rq *rq;
+	int resched_next;
 	int cpu;
 
 need_resched:
@@ -6544,6 +6568,9 @@ need_resched_nonpreemptible:
 	clear_tsk_need_resched(prev);
 	rq->skip_clock_update = 0;
 
+	resched_next = rq->resched_next;
+	rq->resched_next = 0;
+
 	if (likely(prev != next)) {
 		sched_info_switch(prev, next);
 		perf_event_task_sched_out(prev, next);
@@ -6582,11 +6609,12 @@ need_resched_nonpreemptible:
 	if (unlikely(reacquire_kernel_lock(current) < 0))
 		goto need_resched_nonpreemptible;
 
+	if (resched_next)
+		set_tsk_need_resched(current);
+
 	preempt_enable_no_resched();
-	if (need_resched())
+	if (!resched_next && need_resched())
 		goto need_resched;
-
-	task_scheduled(rq, current);
 }
 EXPORT_SYMBOL(schedule);
 
@@ -11975,6 +12003,21 @@ unsigned long sched_cgroup_get_nr_running(struct cgroup *cgrp)
 
 	return sum;
 }
+EXPORT_SYMBOL(sched_cgroup_get_nr_running);
+
+unsigned long sched_cgroup_get_nr_sleep(struct cgroup *cgrp)
+{
+	struct task_group *tg = cgroup_tg(cgrp);
+	unsigned long i, sum = 0;
+
+	/* FIXME make it recursive over sub-cgroups */
+	for_each_online_cpu(i)
+		sum += tg->cfs_rq[i]->nr_unintr;
+
+	return sum;
+}
+EXPORT_SYMBOL(sched_cgroup_get_nr_sleep);
+
 #ifdef CONFIG_CFS_BANDWIDTH
 static DEFINE_MUTEX(cfs_constraints_mutex);
 
diff --git a/kernel/sched_fair.c b/kernel/sched_fair.c
index 6c07fe8..14c2afc 100644
--- a/kernel/sched_fair.c
+++ b/kernel/sched_fair.c
@@ -807,16 +807,24 @@ update_stats_curr_start(struct cfs_rq *cfs_rq, struct sched_entity *se)
 }
 
 #ifdef CONFIG_CFS_BANDWIDTH
+#define BOOSTED_ON_WAKEUP	0x10000
 static inline void update_entity_boost(struct sched_entity *se)
 {
-	if (!entity_is_task(se))
-		se->boosted = cfs_rq_has_boosted_entities(group_cfs_rq(se));
-	else {
+	if (!entity_is_task(se)) {
+		struct cfs_rq *cfs_rq = group_cfs_rq(se);
+
+		if (cfs_rq->nr_boosted_on_wakeup > 0) {
+			WARN_ON_ONCE(!cfs_rq_has_boosted_entities(cfs_rq));
+			se->boosted = BOOSTED_ON_WAKEUP;
+		} else
+			se->boosted = cfs_rq_has_boosted_entities(cfs_rq);
+	} else {
 		struct task_struct *p = task_of(se);
 
 		if (!(preempt_count() & PREEMPT_ACTIVE)) {
 			se->boosted = sched_feat(BOOST_WAKEUPS) &&
-					p->woken_while_running;
+					p->woken_while_running ?
+					BOOSTED_ON_WAKEUP : 0;
 			p->woken_while_running = 0;
 		} else {
 			se->boosted = sched_feat(BOOST_PREEMPT) &&
@@ -828,19 +836,25 @@ static inline void update_entity_boost(struct sched_entity *se)
 static int check_enqueue_boost(struct rq *rq, struct task_struct *p, int flags)
 {
 	if (sched_feat(BOOST_WAKEUPS) && (flags & ENQUEUE_WAKEUP))
-		p->se.boosted = 1;
+		p->se.boosted = BOOSTED_ON_WAKEUP;
 	return p->se.boosted;
 }
 
 static inline void __enqueue_boosted_entity(struct cfs_rq *cfs_rq,
 					    struct sched_entity *se)
 {
+	WARN_ON_ONCE(!se->boosted);
+	if (se->boosted & BOOSTED_ON_WAKEUP)
+		cfs_rq->nr_boosted_on_wakeup++;
 	list_add(&se->boost_node, &cfs_rq->boosted_entities);
 }
 
 static inline void __dequeue_boosted_entity(struct cfs_rq *cfs_rq,
 					    struct sched_entity *se)
 {
+	WARN_ON_ONCE(!se->boosted);
+	if (se->boosted & BOOSTED_ON_WAKEUP)
+		cfs_rq->nr_boosted_on_wakeup--;
 	list_del(&se->boost_node);
 }
 
@@ -848,9 +862,9 @@ static int enqueue_boosted_entity(struct cfs_rq *cfs_rq,
 				  struct sched_entity *se)
 {
 	if (entity_is_task(se) || !entity_boosted(se)) {
+		se->boosted = BOOSTED_ON_WAKEUP;
 		if (se != cfs_rq->curr)
 			__enqueue_boosted_entity(cfs_rq, se);
-		se->boosted = 1;
 		return 1;
 	}
 
@@ -1096,13 +1110,13 @@ static inline u64 SCALE_IDLE_TIME(u64 delta, struct sched_entity *se)
 
 static void enqueue_sleeper(struct cfs_rq *cfs_rq, struct sched_entity *se)
 {
-#ifdef CONFIG_SCHEDSTATS
 	struct task_struct *tsk = NULL;
 
 	if (entity_is_task(se))
 		tsk = task_of(se);
 
 	if (se->sleep_start) {
+#ifdef CONFIG_SCHEDSTATS
 		u64 delta = rq_of(cfs_rq)->clock - se->sleep_start;
 
 		if ((s64)delta < 0)
@@ -1111,17 +1125,18 @@ static void enqueue_sleeper(struct cfs_rq *cfs_rq, struct sched_entity *se)
 		if (unlikely(delta > se->sleep_max))
 			se->sleep_max = delta;
 
-		se->sleep_start = 0;
-
 		if (tsk) {
 			account_scheduler_latency(tsk, delta >> 10, 1);
 			trace_sched_stat_sleep(tsk, delta);
 		} else
 			delta = SCALE_IDLE_TIME(delta, se);
-
 		se->sum_sleep_runtime += delta;
+#endif
+		se->sleep_start = 0;
+		cfs_rq->nr_sleep --;
 	}
 	if (se->block_start) {
+#ifdef CONFIG_SCHEDSTATS
 		u64 delta = rq_of(cfs_rq)->clock - se->block_start;
 
 		if ((s64)delta < 0)
@@ -1130,8 +1145,6 @@ static void enqueue_sleeper(struct cfs_rq *cfs_rq, struct sched_entity *se)
 		if (unlikely(delta > se->block_max))
 			se->block_max = delta;
 
-		se->block_start = 0;
-
 		if (tsk) {
 			if (tsk->in_iowait) {
 				se->iowait_sum += delta;
@@ -1154,22 +1167,26 @@ static void enqueue_sleeper(struct cfs_rq *cfs_rq, struct sched_entity *se)
 			delta = SCALE_IDLE_TIME(delta, se);
 			se->iowait_sum += delta;
 		}
-
 		se->sum_sleep_runtime += delta;
-	}
 #endif
+		se->block_start = 0;
+		cfs_rq->nr_unintr --;
+	}
 }
 
 static void dequeue_sleeper(struct cfs_rq *cfs_rq, struct sched_entity *se)
 {
-#ifdef CONFIG_SCHEDSTATS
 	if (entity_is_task(se)) {
 		struct task_struct *tsk = task_of(se);
 
-		if (tsk->state & TASK_INTERRUPTIBLE)
+		if (tsk->state & TASK_INTERRUPTIBLE) {
 			se->sleep_start = rq_of(cfs_rq)->clock;
-		if (tsk->state & TASK_UNINTERRUPTIBLE)
+			cfs_rq->nr_sleep ++;
+		}
+		if (tsk->state & TASK_UNINTERRUPTIBLE) {
 			se->block_start = rq_of(cfs_rq)->clock;
+			cfs_rq->nr_unintr ++;
+		}
 		if (tsk->in_iowait)
 			cfs_rq->nr_iowait++;
 	} else if (!cfs_rq_throttled(group_cfs_rq(se))) {
@@ -1178,7 +1195,6 @@ static void dequeue_sleeper(struct cfs_rq *cfs_rq, struct sched_entity *se)
 		else
 			se->sleep_start = rq_of(cfs_rq)->clock;
 	}
-#endif
 }
 
 static void stop_cfs_idle_time_accounting(int cpu)
@@ -1470,10 +1486,16 @@ wakeup_preempt_entity(struct sched_entity *curr, struct sched_entity *se);
  * 3) pick the "last" process, for cache locality
  * 4) do not run the "skip" process, if something else is available
  */
-static struct sched_entity *do_pick_next_entity(struct cfs_rq *cfs_rq)
+static struct sched_entity *pick_next_entity(struct cfs_rq *cfs_rq)
 {
 	struct sched_entity *se = __pick_first_entity(cfs_rq);
 	struct sched_entity *left = se;
+#ifdef CONFIG_CFS_BANDWIDTH
+	int quota_exceeded = cfs_rq->runtime_enabled &&
+				cfs_rq->runtime_remaining <= 0;
+	int boost_wakeup = sched_feat(ALWAYS_BOOST_WAKEUPS) &&
+				cfs_rq->nr_boosted_on_wakeup > 0;
+#endif
 
 	/*
 	 * Avoid running the skip buddy, if running something else can
@@ -1497,46 +1519,45 @@ static struct sched_entity *do_pick_next_entity(struct cfs_rq *cfs_rq)
 	if (cfs_rq->next && wakeup_preempt_entity(cfs_rq->next, left) < 1)
 		se = cfs_rq->next;
 
-	clear_buddies(cfs_rq, se);
-
-	return se;
-}
-
 #ifdef CONFIG_CFS_BANDWIDTH
-static struct sched_entity *pick_next_entity(struct cfs_rq *cfs_rq)
-{
-	struct rq *rq = rq_of(cfs_rq);
-	struct sched_entity *se = NULL;
+	/*
+	 * Give boosted tasks a chance to finish their kernel-mode execution in
+	 * order to avoid prio inversion in case they hold a lock, but resched
+	 * them asap for the sake of fairness.
+	 */
+	if (quota_exceeded || boost_wakeup) {
+		struct rq *rq = rq_of(cfs_rq);
 
-	if (cfs_rq->runtime_enabled && cfs_rq->runtime_remaining <= 0) {
-		rq->cfs_quota_exceeded = 1;
 		if (cfs_rq_has_boosted_entities(cfs_rq)) {
-			se = list_first_entry(&cfs_rq->boosted_entities,
-					      struct sched_entity, boost_node);
-			clear_buddies(cfs_rq, se);
-		}
-	}
+			struct sched_entity *boosted = NULL, *tmp;
+
+			list_for_each_entry(tmp,
+				&cfs_rq->boosted_entities, boost_node) {
+				if (!boost_wakeup ||
+				    (tmp->boosted & BOOSTED_ON_WAKEUP)) {
+					boosted = tmp;
+					break;
+				}
+			}
+			if (boosted) {
+				if (boosted != se && boosted != left)
+					rq->resched_next = 1;
+				se = boosted;
+			} else
+				WARN_ON_ONCE(1);
+		} else
+			WARN_ON_ONCE(boost_wakeup);
 
-	if (!se)
-		se = do_pick_next_entity(cfs_rq);
+		if (quota_exceeded)
+			rq->resched_next = 1;
+	}
+#endif
 
-	if (entity_is_task(se) &&
-	    !entity_boosted(se) && rq->cfs_quota_exceeded)
-		resched_task(task_of(se));
+	clear_buddies(cfs_rq, se);
 
 	return se;
 }
 
-static void task_scheduled_fair(struct rq *rq, struct task_struct *p)
-{
-	if (rq->cfs_quota_exceeded)
-		set_tsk_need_resched(p);
-	rq->cfs_quota_exceeded = 0;
-}
-#else
-# define pick_next_entity do_pick_next_entity
-#endif
-
 static void check_cfs_rq_runtime(struct cfs_rq *cfs_rq);
 static void unthrottle_cfs_rq(struct cfs_rq *cfs_rq);
 
@@ -3011,6 +3032,15 @@ static struct task_struct *pick_next_task_fair(struct rq *rq)
 	p = task_of(se);
 	hrtick_start_fair(rq, p);
 
+	if (rq->resched_next && !entity_boosted(&p->se)) {
+		/*
+		 * seems boosted tasks have gone from the throttled cfs_rq,
+		 * pick another task then
+		 */
+		resched_task(p);
+		rq->resched_next = 0;
+	}
+
 	return p;
 }
 
@@ -3647,9 +3677,6 @@ static const struct sched_class fair_sched_class = {
 	.nr_iowait_inc		= nr_iowait_inc_fair,
 	.nr_iowait_dec		= nr_iowait_dec_fair,
 #endif
-#ifdef CONFIG_CFS_BANDWIDTH
-	.task_scheduled		= task_scheduled_fair,
-#endif
 };
 
 #ifdef CONFIG_SCHED_DEBUG
diff --git a/kernel/sched_features.h b/kernel/sched_features.h
index 087153c..16b1ab5 100644
--- a/kernel/sched_features.h
+++ b/kernel/sched_features.h
@@ -62,3 +62,4 @@ SCHED_FEAT(OWNER_SPIN, 1)
 
 SCHED_FEAT(BOOST_WAKEUPS, 1)
 SCHED_FEAT(BOOST_PREEMPT, 1)
+SCHED_FEAT(ALWAYS_BOOST_WAKEUPS, 0)
diff --git a/kernel/sysctl.c b/kernel/sysctl.c
index 3c6350f..e8d7745 100644
--- a/kernel/sysctl.c
+++ b/kernel/sysctl.c
@@ -96,6 +96,7 @@ extern int percpu_pagelist_fraction;
 extern int compat_log;
 int ve_allow_kthreads = 1;
 EXPORT_SYMBOL(ve_allow_kthreads);
+extern int user_ptrace_enabled;
 
 #ifdef CONFIG_MAGIC_SYSRQ
 extern int sysrq_key_scancode;
@@ -116,7 +117,13 @@ extern int sysctl_nr_trim_pages;
 extern int kexec_load_disabled;
 extern int kexec_preserve_uptime;
 extern int kexec_reuse_crash;
+#ifdef CONFIG_PRAMCACHE
 extern int pramcache_ploop_nosync;
+#endif
+#ifdef CONFIG_SYMLINKOWN
+extern int enable_symlinkown;
+extern int symlinkown_gid;
+#endif
 /* bz790921 */
 int unmap_area_factor_sysctl_handler(ctl_table *table, int write,
 			void __user *buffer, size_t *length, loff_t *ppos);
@@ -1335,6 +1342,14 @@ static struct ctl_table kern_table[] = {
 		.proc_handler	= &proc_dointvec,
 	},
 #endif
+	{
+		.ctl_name	= CTL_UNNUMBERED,
+		.procname	= "user_ptrace",
+		.data		= &user_ptrace_enabled,
+		.maxlen		= sizeof(int),
+		.mode		= 0644,
+		.proc_handler	= &proc_dointvec,
+	},
 /*
  * NOTE: do not add new entries to this table unless you have read
  * Documentation/sysctl/ctl_unnumbered.txt
@@ -1911,6 +1926,9 @@ static struct ctl_table binfmt_misc_table[] = {
 };
 #endif
 
+extern int proc_can_see_other_uid; /* fs/procfs/ */
+extern gid_t proc_super_gid;
+
 static struct ctl_table fs_table[] = {
 	{
 		.ctl_name	= CTL_UNNUMBERED,
@@ -2089,6 +2107,40 @@ static struct ctl_table fs_table[] = {
 		.mode		= 0644,
 		.proc_handler	= proc_dointvec,
 	},
+	{
+		.ctl_name	= CTL_UNNUMBERED,
+		.procname	= "proc_can_see_other_uid",
+		.mode		= 0600,
+		.data		= &proc_can_see_other_uid,
+		.maxlen		= sizeof(proc_can_see_other_uid),
+		.proc_handler	= &proc_dointvec,
+	},
+	{
+		.ctl_name	= CTL_UNNUMBERED,
+		.procname	= "proc_super_gid",
+		.mode		= 0600,
+		.data		= &proc_super_gid,
+		.maxlen		= sizeof(proc_super_gid),
+		.proc_handler	= &proc_dointvec,
+	},
+#ifdef CONFIG_SYMLINKOWN
+	{
+		.ctl_name	= CTL_UNNUMBERED,
+		.procname	= "enforce_symlinksifowner",
+		.mode		= 0600,
+		.data		= &enable_symlinkown,
+		.maxlen		= sizeof(enable_symlinkown),
+		.proc_handler	= &proc_dointvec,
+	},
+	{
+		.ctl_name	= CTL_UNNUMBERED,
+		.procname	= "symlinkown_gid",
+		.mode		= 0600,
+		.data		= &symlinkown_gid,
+		.maxlen		= sizeof(symlinkown_gid),
+		.proc_handler   = &proc_dointvec,
+	},
+#endif
 #ifdef CONFIG_PRAMCACHE
 	{
 		.procname	= "pramcache",
diff --git a/kernel/ve/ve.c b/kernel/ve/ve.c
index 554c3f5..9c20573 100644
--- a/kernel/ve/ve.c
+++ b/kernel/ve/ve.c
@@ -41,6 +41,8 @@
 
 #include <linux/vzcalluser.h>
 
+#include <bc/task.h>
+
 unsigned long vz_rstamp = 0x37e0f59d;
 EXPORT_SYMBOL(vz_rstamp);
 
@@ -145,6 +147,7 @@ void init_ve0(void)
 	struct ve_struct *ve;
 
 	ve = get_ve0();
+	ve->vs_ubc = get_ub0();
 	ve->sched_lat_ve.cur = &per_cpu_var(ve0_lat_stats);
 	list_add(&ve->ve_list, &ve_list_head);
 	INIT_LIST_HEAD(&ve->_kthread_create_list);
diff --git a/kernel/ve/vecalls.c b/kernel/ve/vecalls.c
index 00587f8..1a700d5 100644
--- a/kernel/ve/vecalls.c
+++ b/kernel/ve/vecalls.c
@@ -1312,6 +1312,7 @@ static int do_env_create(envid_t veid, unsigned int flags, u32 class_id,
 	init_mask = setup_iptables_mask(init_mask);
 	ve->ipt_mask = init_mask;
 #endif
+	ve->vs_ubc = get_exec_ub();
 
 	if ((err = init_ve_netns(ve, &old_ns_net)))
 		goto err_netns;
diff --git a/mm/filemap.c b/mm/filemap.c
index 1d9035d..dacc7fb 100644
--- a/mm/filemap.c
+++ b/mm/filemap.c
@@ -2494,8 +2494,6 @@ generic_file_buffered_write_iter(struct kiocb *iocb, struct iov_iter *iter,
 	struct address_space *mapping = file->f_mapping;
 	ssize_t status;
 
-	virtinfo_notifier_call(VITYPE_IO, VIRTINFO_IO_PREPARE, NULL);
-
 	status = generic_perform_write(file, iter, pos);
 
 	if (likely(status >= 0)) {
@@ -2649,6 +2647,8 @@ ssize_t generic_file_write_iter(struct kiocb *iocb, struct iov_iter *iter,
 	struct inode *inode = file->f_mapping->host;
 	ssize_t ret;
 
+	virtinfo_notifier_call(VITYPE_IO, VIRTINFO_IO_PREPARE, NULL);
+
 	mutex_lock(&inode->i_mutex);
 	ret = __generic_file_write_iter(iocb, iter, &iocb->ki_pos);
 	mutex_unlock(&inode->i_mutex);
@@ -2705,6 +2705,8 @@ ssize_t generic_file_aio_write(struct kiocb *iocb, const struct iovec *iov,
 
 	BUG_ON(iocb->ki_pos != pos);
 
+	virtinfo_notifier_call(VITYPE_IO, VIRTINFO_IO_PREPARE, NULL);
+
 	sb_start_write(inode->i_sb);
 	mutex_lock(&inode->i_mutex);
 	ret = __generic_file_aio_write(iocb, iov, nr_segs, &iocb->ki_pos);
diff --git a/mm/mmzone.c b/mm/mmzone.c
index 620b1e5..a8e4492 100644
--- a/mm/mmzone.c
+++ b/mm/mmzone.c
@@ -417,6 +417,9 @@ static void init_gangs_migration_work(struct gang_set *gs);
 static inline void init_gangs_migration_work(struct gang_set *gs) { }
 #endif
 
+static struct kmem_cache *gangs_cachep;
+static struct kmem_cache *gangs_large_cachep;
+
 int alloc_mem_gangs(struct gang_set *gs)
 {
 	struct zone *zone;
@@ -433,14 +436,16 @@ int alloc_mem_gangs(struct gang_set *gs)
 	BUILD_BUG_ON(sizeof(struct gang) * MAX_NR_ZONES > (PAGE_SIZE << 2));
 
 	for_each_node(node) {
-		gs->gangs[node] = kzalloc_node(sizeof(struct gang)
-				* MAX_NR_ZONES, GFP_KERNEL, node);
+		gs->gangs[node] = kmem_cache_alloc_node(gangs_large_cachep,
+							GFP_KERNEL | __GFP_ZERO,
+							node);
 		if (!gs->gangs[node])
 			goto nomem;
 		for (zid = 0; zid < MAX_NR_ZONES; zid++) {
 			gs->gangs[node][zid].shadow =
-				kzalloc_node(sizeof(struct gang),
-						GFP_KERNEL, node);
+				kmem_cache_alloc_node(gangs_cachep,
+							GFP_KERNEL | __GFP_ZERO,
+							node);
 			if (!gs->gangs[node][zid].shadow)
 				goto nomem;
 		}
@@ -464,6 +469,18 @@ noarr:
 	return -ENOMEM;
 }
 
+static __init int init_mem_gangs_cache(void)
+{
+	gangs_large_cachep = kmem_cache_create("gangs_large",
+			sizeof(struct gang) * MAX_NR_ZONES, 0, SLAB_PANIC, NULL);
+
+	gangs_cachep = kmem_cache_create("gangs", sizeof(struct gang),
+					 0, SLAB_PANIC, NULL);
+
+	return 0;
+}
+late_initcall(init_mem_gangs_cache);
+
 void free_mem_gangs(struct gang_set *gs)
 {
 	int node, zid;
diff --git a/mm/page-writeback.c b/mm/page-writeback.c
index d3b3a5a..8bfda9f 100644
--- a/mm/page-writeback.c
+++ b/mm/page-writeback.c
@@ -42,6 +42,26 @@
  * will look to see if it needs to force writeback or throttling.
  */
 static long ratelimit_pages = 32;
+static long ratelimit_pages_max = (4096 * 1024) / PAGE_CACHE_SIZE;
+
+static int __init set_ratelimit_pages_max(char *str)
+{
+	long rlp_max;
+
+	if (!str)
+		return 0;
+
+	rlp_max = simple_strtoul(str, &str, 0);
+	if (rlp_max < 16) {
+		printk("wrong ratelimit_pages_max\n");
+		return 0;
+	}
+
+	ratelimit_pages_max = rlp_max;
+
+	return 1;
+}
+__setup("rlp_max=", set_ratelimit_pages_max);
 
 /*
  * When balance_dirty_pages decides that the caller needs to perform some
@@ -867,8 +887,8 @@ void writeback_set_ratelimit(void)
 	ratelimit_pages = vm_total_pages / (num_online_cpus() * 32);
 	if (ratelimit_pages < 16)
 		ratelimit_pages = 16;
-	if (ratelimit_pages * PAGE_CACHE_SIZE > 4096 * 1024)
-		ratelimit_pages = (4096 * 1024) / PAGE_CACHE_SIZE;
+	if (ratelimit_pages > ratelimit_pages_max)
+		ratelimit_pages = ratelimit_pages_max;
 }
 
 static int __cpuinit
diff --git a/mm/rmap.c b/mm/rmap.c
index e603c53..941c7b5 100644
--- a/mm/rmap.c
+++ b/mm/rmap.c
@@ -73,7 +73,7 @@ static struct kmem_cache *anon_vma_chain_cachep;
 
 static inline struct anon_vma *anon_vma_alloc(struct mm_struct *mm)
 {
-	struct user_beancounter *ub = mm->mm_ub;
+	struct user_beancounter *ub = ub_param_allow(UB_KMEMSIZE) ? mm->mm_ub : get_ub0();
 	struct anon_vma *anon_vma;
 
 	anon_vma = ub_kmem_alloc(ub, anon_vma_cachep, GFP_KERNEL);
diff --git a/mm/shmem.c b/mm/shmem.c
index 6721751..90c97d0 100644
--- a/mm/shmem.c
+++ b/mm/shmem.c
@@ -2218,8 +2218,10 @@ static struct kmem_cache *shmem_inode_cachep;
 
 static struct inode *shmem_alloc_inode(struct super_block *sb)
 {
-	struct user_beancounter *ub = get_exec_ub();
+	struct user_beancounter *ub = ub_param_allow(UB_KMEMSIZE) ?
+					get_exec_ub() : get_ub0();
 	struct shmem_inode_info *info;
+
 	info = ub_kmem_alloc(ub, shmem_inode_cachep, GFP_KERNEL);
 	if (!info)
 		return NULL;
@@ -2485,6 +2487,7 @@ struct file *shmem_file_setup(const char *name, loff_t size, unsigned long flags
 	struct path path;
 	struct dentry *root;
 	struct qstr this;
+	struct user_beancounter *ub;
 
 	if (IS_ERR(shm_mnt))
 		return (void *)shm_mnt;
@@ -2492,7 +2495,9 @@ struct file *shmem_file_setup(const char *name, loff_t size, unsigned long flags
 	if (size < 0 || size > MAX_LFS_FILESIZE)
 		return ERR_PTR(-EINVAL);
 
-	if (shmem_acct_size(flags, size, get_exec_ub()))
+	ub = ub_param_allow(UB_KMEMSIZE) ? get_exec_ub() : get_ub0();
+
+	if (shmem_acct_size(flags, size, ub))
 		return ERR_PTR(-ENOMEM);
 
 	error = -ENOMEM;
diff --git a/net/netfilter/x_tables.c b/net/netfilter/x_tables.c
index cea12a6..f42dce2 100644
--- a/net/netfilter/x_tables.c
+++ b/net/netfilter/x_tables.c
@@ -72,48 +72,28 @@ static const char *const xt_prefix[NFPROTO_NUMPROTO] = {
 };
 
 #ifdef CONFIG_BEANCOUNTERS
-static inline struct user_beancounter *xt_table_ub(struct xt_table_info *info)
+static void uncharge_xtables(struct user_beancounter *ub, unsigned long size)
 {
-	return mem_ub(info);
-}
-
-static void uncharge_xtables(struct xt_table_info *info, unsigned long size)
-{
-	struct user_beancounter *ub;
-
-	ub = xt_table_ub(info);
 	uncharge_beancounter(ub, UB_NUMXTENT, size);
 }
 
-static int recharge_xtables(struct xt_table_info *new, struct xt_table_info *old)
+static int recharge_xtables(struct user_beancounter *ub,
+			    struct xt_table_info *new, struct xt_table_info *old)
 {
-	struct user_beancounter *ub, *old_ub;
 	long change;
 
-	ub = xt_table_ub(new);
-	old_ub = old->number ? xt_table_ub(old) : ub;
 	change = (long)new->number - (long)old->number;
-	if (old_ub != ub) {
-		printk(KERN_WARNING "iptables resources are charged"
-				" from different UB (%d -> %d)\n",
-				old_ub->ub_uid, ub->ub_uid);
-		change = new->number;
-	}
-
 	if (change > 0) {
 		if (charge_beancounter(ub, UB_NUMXTENT, change, UB_SOFT))
 			return -ENOMEM;
 	} else if (change < 0)
 		uncharge_beancounter(ub, UB_NUMXTENT, -change);
 
-	if (old_ub != ub)
-		uncharge_beancounter(old_ub, UB_NUMXTENT, old->number);
-
 	return 0;
 }
 #else
-#define recharge_xtables(c, new, old)	(0)
-#define uncharge_xtables(info, s)	do { } while (0)
+#define recharge_xtables(ubc, new, old)	(0)
+#define uncharge_xtables(ubc, s)	do { } while (0)
 #endif	/* CONFIG_BEANCOUNTERS */
 
 /* Registration hooks for targets. */
@@ -771,7 +751,7 @@ xt_replace_table(struct xt_table *table,
 		return NULL;
 	}
 
-	if (recharge_xtables(newinfo, private)) {
+	if (recharge_xtables(get_exec_env()->vs_ubc, newinfo, private)) {
 		local_bh_enable();
 		*error = -ENOMEM;
 		return NULL;
@@ -837,7 +817,6 @@ struct xt_table *xt_register_table(struct net *net,
 
 	/* Simplifies replace_table code. */
 	table->private = bootstrap;
-
 	if (!xt_replace_table(table, 0, newinfo, &ret))
 		goto unlock;
 
@@ -869,7 +848,7 @@ void *xt_unregister_table(struct xt_table *table)
 	list_del(&table->list);
 	mutex_unlock(&xt[table->af].mutex);
 	kfree(table);
-	uncharge_xtables(private, private->number);
+	uncharge_xtables(get_exec_env()->vs_ubc, private->number);
 
 	return private;
 }
diff --git a/net/sunrpc/svc_xprt.c b/net/sunrpc/svc_xprt.c
index 2661e7f..e9cdfa8 100644
--- a/net/sunrpc/svc_xprt.c
+++ b/net/sunrpc/svc_xprt.c
@@ -94,6 +94,8 @@ void svc_unreg_xprt_class(struct svc_xprt_class *xcl)
 }
 EXPORT_SYMBOL_GPL(svc_unreg_xprt_class);
 
+extern atomic_long_t xprt_slot_alloc_failures;
+
 /*
  * Format the transport list for printing
  */
@@ -101,13 +103,11 @@ int svc_print_xprts(char *buf, int maxlen)
 {
 	struct svc_xprt_class *xcl;
 	char tmpstr[80];
-	int len = 0;
+	int len = 0, slen;
 	buf[0] = '\0';
 
 	spin_lock(&svc_xprt_class_lock);
 	list_for_each_entry(xcl, &svc_xprt_class_list, xcl_list) {
-		int slen;
-
 		sprintf(tmpstr, "%s %d\n", xcl->xcl_name, xcl->xcl_max_payload);
 		slen = strlen(tmpstr);
 		if (len + slen > maxlen)
@@ -116,6 +116,13 @@ int svc_print_xprts(char *buf, int maxlen)
 		strcat(buf, tmpstr);
 	}
 	spin_unlock(&svc_xprt_class_lock);
+	sprintf(tmpstr, "xprt_slot_alloc_failures %ld\n",
+		atomic_long_read(&xprt_slot_alloc_failures));
+	slen = strlen(tmpstr);
+	if (len + slen <= maxlen) {
+		len += slen;
+		strcat(buf, tmpstr);
+	}
 
 	return len;
 }
diff --git a/net/sunrpc/xprt.c b/net/sunrpc/xprt.c
index c868af7..b4b3f4b 100644
--- a/net/sunrpc/xprt.c
+++ b/net/sunrpc/xprt.c
@@ -961,12 +961,16 @@ void xprt_transmit(struct rpc_task *task)
 	spin_unlock_bh(&xprt->transport_lock);
 }
 
+atomic_long_t xprt_slot_alloc_failures = ATOMIC_LONG_INIT(0);
+
 static struct rpc_rqst *xprt_dynamic_alloc_slot(struct rpc_xprt *xprt, gfp_t gfp_flags)
 {
 	struct rpc_rqst *req = ERR_PTR(-EAGAIN);
 
-	if (!atomic_add_unless(&xprt->num_reqs, 1, xprt->max_reqs))
+	if (!atomic_add_unless(&xprt->num_reqs, 1, xprt->max_reqs)) {
+		atomic_long_inc(&xprt_slot_alloc_failures);
 		goto out;
+	}
 	req = kzalloc(sizeof(struct rpc_rqst), gfp_flags);
 	if (req != NULL)
 		goto out;
